// Begin Code : Import the various packages necessary
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import quadbase.reportdesigner.ReportAPI.QbReport;

public class SwitchDrillDownServlet extends HttpServlet
{
	static final long serialVersionUID = 1;

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException,
			IOException
	{
		HttpSession session = req.getSession(true);

		// Set the "content type" header of the response
		res.setContentType("text/html");

		// Get the response's OutputStream to return content to the client.
		OutputStream toClient = res.getOutputStream();

		try
		{
			// Do not use EspressManager
			QbReport.setEspressManagerUsed(false);

			// Open report with backup data (data source will be switched later)
			QbReport report = new QbReport(null, "SwitchDrillDownServlet.pak",
					false, false, false, true);

			// New database connection information
			String newDatabaseURL = "jdbc:hsqldb:woodview";
			String newDatabaseDriver = "org.hsqldb.jdbcDriver";
			String newDatabaseUID = "sa";
			String newDatabasePassword = "";

			// Switch data source
			report.getInputData().setAllDatabaseInfo(newDatabaseURL, newDatabaseDriver,
					newDatabaseUID, newDatabasePassword);

			// Put new data source information in session for DrillDownReportServlet
			report.setDrillDownDatabaseInfo(session, newDatabaseURL, newDatabaseDriver,
					newDatabaseUID, newDatabasePassword);

			report.setDynamicExport(true, "localhost", 8080);

			ByteArrayOutputStream tempStream = new ByteArrayOutputStream();

			report.refresh();

			// Export the report to DHTML
			report.export(QbReport.DHTML, tempStream);

			tempStream.writeTo(toClient);
		} catch (Exception e) {
			e.printStackTrace();
		}

		// Flush the outputStream
		toClient.flush();

		// Close the writer; the response is done.
		toClient.close();
	}

	@Override
	public String getServletInfo()
	{
		return "Export Servlet for switching Drill Down report";
	}
}
